/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   case_item.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CASE_ITEM_H
#define UHDM_CASE_ITEM_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>

#include "pattern_expr_group.h"
#include "stmt.h"


namespace UHDM {


class case_item final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(case_item, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: case_item();
  virtual ~case_item() final = default;

  VectorOfany* VpiExprs() const { return vpiExprs_; }
  bool VpiExprs(VectorOfany* data) {
    if (!pattern_expr_groupGroupCompliant(data)) return false;
    vpiExprs_ = data;
    return true;
  }

  any* Stmt()  { return stmt_; }
  const any* Stmt() const { return stmt_; }
  template <typename T>
  T* Stmt() {
    return (stmt_ == nullptr) ? nullptr : any_cast<T*>(stmt_);
  }
  template <typename T>
  const T* Stmt() const {
    return (stmt_ == nullptr) ? nullptr : any_cast<const T*>(stmt_);
  }
  bool Stmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    stmt_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiCaseItem; }

  virtual case_item* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmcase_item; }

protected:
  void DeepCopy(case_item* clone, BaseClass* parent, CloneContext* context) const;

private:
  VectorOfany* vpiExprs_ = nullptr;

  any* stmt_ = nullptr;
};


typedef FactoryT<case_item> case_itemFactory;


typedef FactoryT<std::vector<case_item *>> VectorOfcase_itemFactory;

}  // namespace UHDM

#endif
