/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   delay_control.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_DELAY_CONTROL_H
#define UHDM_DELAY_CONTROL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/atomic_stmt.h>

#include "stmt.h"


namespace UHDM {
class expr;

class delay_control final : public atomic_stmt {
  UHDM_IMPLEMENT_RTTI(delay_control, atomic_stmt)
public:
  // Implicit constructor used to initialize all members,
  // comment: delay_control();
  virtual ~delay_control() final = default;

  bool VpiDelay(std::string_view data);
  std::string_view VpiDelay() const;

  any* Stmt()  { return stmt_; }
  const any* Stmt() const { return stmt_; }
  template <typename T>
  T* Stmt() {
    return (stmt_ == nullptr) ? nullptr : any_cast<T*>(stmt_);
  }
  template <typename T>
  const T* Stmt() const {
    return (stmt_ == nullptr) ? nullptr : any_cast<const T*>(stmt_);
  }
  bool Stmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    stmt_ = data;
    return true;
  }

  expr* Delay()  { return delay_; }
  const expr* Delay() const { return delay_; }
  template <typename T>
  T* Delay() {
    return (delay_ == nullptr) ? nullptr : any_cast<T*>(delay_);
  }
  template <typename T>
  const T* Delay() const {
    return (delay_ == nullptr) ? nullptr : any_cast<const T*>(delay_);
  }
  bool Delay(expr* data) {
    delay_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiDelayControl; }

  virtual delay_control* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmdelay_control; }

protected:
  void DeepCopy(delay_control* clone, BaseClass* parent, CloneContext* context) const;

private:
  SymbolId vpiDelay_;

  any* stmt_ = nullptr;

  expr* delay_ = nullptr;
};


typedef FactoryT<delay_control> delay_controlFactory;


typedef FactoryT<std::vector<delay_control *>> VectorOfdelay_controlFactory;

}  // namespace UHDM

#endif
