/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   expr.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_EXPR_H
#define UHDM_EXPR_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class ref_typespec;

class expr : public BaseClass {
  UHDM_IMPLEMENT_RTTI(expr, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: expr();
  virtual ~expr() = default;

  bool VpiDecompile(std::string_view data);
  std::string_view VpiDecompile() const;

  int32_t VpiSize() const { return vpiSize_; }
  bool VpiSize(int32_t data) {
    vpiSize_ = data;
    return true;
  }

  bool VpiValue(std::string_view data);
  std::string_view VpiValue() const;

  ref_typespec* Typespec()  { return typespec_; }
  const ref_typespec* Typespec() const { return typespec_; }
  template <typename T>
  T* Typespec() {
    return (typespec_ == nullptr) ? nullptr : any_cast<T*>(typespec_);
  }
  template <typename T>
  const T* Typespec() const {
    return (typespec_ == nullptr) ? nullptr : any_cast<const T*>(typespec_);
  }
  bool Typespec(ref_typespec* data) {
    typespec_ = data;
    return true;
  }

  virtual expr* DeepClone(BaseClass* parent, CloneContext* context) const override = 0;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const override { return UHDM_OBJECT_TYPE::uhdmexpr; }

protected:
  void DeepCopy(expr* clone, BaseClass* parent, CloneContext* context) const;

private:
  SymbolId vpiDecompile_;

  int32_t vpiSize_ = 0;

  SymbolId vpiValue_;

  ref_typespec* typespec_ = nullptr;
};

#if 0 // This class cannot be instantiated
typedef FactoryT<expr> exprFactory;
#endif

typedef FactoryT<std::vector<expr *>> VectorOfexprFactory;

}  // namespace UHDM

#endif
