/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   property_inst.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PROPERTY_INST_H
#define UHDM_PROPERTY_INST_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>

#include "expr_dist.h"
#include "property_expr_named_event_group.h"


namespace UHDM {
class clocking_block;
class property_decl;

class property_inst final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(property_inst, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: property_inst();
  virtual ~property_inst() final = default;

  any* VpiDisableCondition()  { return vpiDisableCondition_; }
  const any* VpiDisableCondition() const { return vpiDisableCondition_; }
  template <typename T>
  T* VpiDisableCondition() {
    return (vpiDisableCondition_ == nullptr) ? nullptr : any_cast<T*>(vpiDisableCondition_);
  }
  template <typename T>
  const T* VpiDisableCondition() const {
    return (vpiDisableCondition_ == nullptr) ? nullptr : any_cast<const T*>(vpiDisableCondition_);
  }
  bool VpiDisableCondition(any* data) {
    if (!expr_distGroupCompliant(data)) return false;
    vpiDisableCondition_ = data;
    return true;
  }

  VectorOfany* VpiArguments() const { return vpiArguments_; }
  bool VpiArguments(VectorOfany* data) {
    if (!property_expr_named_event_groupGroupCompliant(data)) return false;
    vpiArguments_ = data;
    return true;
  }

  property_decl* Property_decl()  { return property_decl_; }
  const property_decl* Property_decl() const { return property_decl_; }
  template <typename T>
  T* Property_decl() {
    return (property_decl_ == nullptr) ? nullptr : any_cast<T*>(property_decl_);
  }
  template <typename T>
  const T* Property_decl() const {
    return (property_decl_ == nullptr) ? nullptr : any_cast<const T*>(property_decl_);
  }
  bool Property_decl(property_decl* data) {
    property_decl_ = data;
    return true;
  }

  virtual bool VpiName(std::string_view data) final;
  virtual std::string_view VpiName() const final;

  clocking_block* Clocking_block()  { return clocking_block_; }
  const clocking_block* Clocking_block() const { return clocking_block_; }
  template <typename T>
  T* Clocking_block() {
    return (clocking_block_ == nullptr) ? nullptr : any_cast<T*>(clocking_block_);
  }
  template <typename T>
  const T* Clocking_block() const {
    return (clocking_block_ == nullptr) ? nullptr : any_cast<const T*>(clocking_block_);
  }
  bool Clocking_block(clocking_block* data) {
    clocking_block_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiPropertyInst; }

  virtual property_inst* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmproperty_inst; }

protected:
  void DeepCopy(property_inst* clone, BaseClass* parent, CloneContext* context) const;

private:
  any* vpiDisableCondition_ = nullptr;

  VectorOfany* vpiArguments_ = nullptr;

  property_decl* property_decl_ = nullptr;

  SymbolId vpiName_;

  clocking_block* clocking_block_ = nullptr;
};


typedef FactoryT<property_inst> property_instFactory;


typedef FactoryT<std::vector<property_inst *>> VectorOfproperty_instFactory;

}  // namespace UHDM

#endif
